// (C) Copyright 2003-2004: Reece H. Dunn; Jonathan Turkanis
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef BOOST_IOFM_DETAIL_CONFIG_HPP
#define BOOST_IOFM_DETAIL_CONFIG_HPP
#  if(( defined(_MSC_VER) && (_MSC_VER >= 1020 )) || defined(__WAVE__))
#     pragma once
#  endif

#  include <boost/config.hpp>

   // hash containers (library extension) support

#  if defined(BOOST_HAS_HASH)
#     define BOOST_STDEXT_HASH_CONTAINERS        // SGI hash containers
#     define BOOST_STDEXT_HASH_MAP_T             typename KeyT, typename T, class Hash, class Cmp, class Allocator
#     define BOOST_STDEXT_HASH_MAP_ARG           KeyT, T, Hash, Cmp, Allocator
#     define BOOST_STDEXT_HASH_SET_T             typename KeyT, class Hash, class Cmp, class Allocator
#     define BOOST_STDEXT_HASH_SET_ARG           KeyT, Hash, Cmp, Allocator
#  elif defined(BOOST_DINKUMWARE_STDLIB) && (BOOST_DINKUMWARE_STDLIB >= 306)
#     define BOOST_STDEXT_HASH_CONTAINERS        // Dinkumware hash containers
#     define BOOST_STDEXT_HASH_MAP_T             typename KeyT, typename T, class Cmp, class Allocator
#     define BOOST_STDEXT_HASH_MAP_ARG           KeyT, T, Cmp, Allocator
#     define BOOST_STDEXT_HASH_SET_T             typename KeyT, class Cmp, class Allocator
#     define BOOST_STDEXT_HASH_SET_ARG           KeyT, Cmp, Allocator
#  endif

   // extension namespace for hash/slist containers - fix for VC7.1+

#  if defined(_CPPLIB_VER) && (_CPPLIB_VER >= 313)   // Dinkumware stdlib 313+
#     if defined(BOOST_MSVC) && (BOOST_MSVC >= 1310) // MS VC7.1+
#        define BOOST_STDEXT_NAMESPACE           stdext
#     endif
#  endif

#  if !defined(BOOST_STDEXT_NAMESPACE)
#     define BOOST_STDEXT_NAMESPACE              BOOST_STD_EXTENSION_NAMESPACE
#  endif

   // basic_*stream support

#  if defined(BOOST_NO_STD_LOCALE) // new I/O streams are broken or not implemented...
#     define BOOST_IO_NO_BASIC_STREAM  // use old I/O streams
#  endif

   // Compiler/Library specific information

#  if defined(__BORLANDC__)
#  elif defined(__COMO__)
#  elif defined(__GNUC__)
#     if( __GNUC__ == 2 )
#     endif
#  elif defined(__INTEL_COMPILER) || defined(__ICL) || defined(__ICC) || defined(__ECC)
#     define BOOST_IO_NO_DEPRECATED_MODIFIER // __declspec(deprecated) not supported
#  elif defined(__MWERKS__)
#  elif defined(_MSC_VER)
#     if( _MSC_VER < 1300 )
#     endif
#  endif

   // include <locale> with Intel compiler fix with Dinkumware libraries

#  if defined(BOOST_IO_NO_DEPRECATED_MODIFIER) && defined(BOOST_DINKUMWARE_STDLIB)
#     define _DEPRECATED_TEMP _DEPRECATED
#     define _DEPRECATED
#     include <istream>
#     include <ostream>
#     include <locale>
#     define _DEPRECATED _DEPRECATED_TEMP
#  else
#     include <istream>
#     include <ostream>
#     include <locale>
#  endif

#endif
