// (C) Copyright 2004: Reece H. Dunn
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef BOOST_FORMATTER_FORMAT_OBJECTS_BASIC_HPP
#define BOOST_FORMATTER_FORMAT_OBJECTS_BASIC_HPP

namespace boost { namespace io { namespace format
{
   class basic
   {
      public:
         template< typename T, class InputStream >
         static inline InputStream &             read( InputStream & is, T & value )
         {
            is >> value;
            return( !is.fail());
         }
         template< typename T, class OutputStream >
         static inline OutputStream &            write( OutputStream & os, const T & value )
         {
            return( os << value );
         }
   };
}}}

#endif
