// (C) Copyright 2004: Reece H. Dunn
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <boost/formatter/decorators.hpp>
#include <iostream>

namespace io = boost::io;

int main()
{
   io::wrapper_decorators< char >      wrap;
   io::sequence_decorators< char >     seq;

   std::cout << "using internal values...\n";

   std::cout << "wrap.open()     = " << wrap.open()     << '\n';
   std::cout << "wrap.close()    = " << wrap.close()    << '\n';
   std::cout << "seq.open()      = " << seq.open()      << '\n';
   std::cout << "seq.close()     = " << seq.close()     << '\n';
   std::cout << "seq.separator() = " << seq.separator() << '\n';

   std::cout << "using default stream decoration...\n";

   std::cout << "wrap.open(     std::cout ) = " << wrap.open(     std::cout ) << '\n';
   std::cout << "wrap.close(    std::cout ) = " << wrap.close(    std::cout ) << '\n';
   std::cout << "seq.open(      std::cout ) = " << seq.open(      std::cout ) << '\n';
   std::cout << "seq.close(     std::cout ) = " << seq.close(     std::cout ) << '\n';
   std::cout << "seq.separator( std::cout ) = " << seq.separator( std::cout ) << '\n';

   std::cout << "using custom stream decoration...\n"
             << io::cdecorate( "<-- ", " -->", "-:-" );

   std::cout << "wrap.open(     std::cout ) = " << wrap.open(     std::cout ) << '\n';
   std::cout << "wrap.close(    std::cout ) = " << wrap.close(    std::cout ) << '\n';
   std::cout << "seq.open(      std::cout ) = " << seq.open(      std::cout ) << '\n';
   std::cout << "seq.close(     std::cout ) = " << seq.close(     std::cout ) << '\n';
   std::cout << "seq.separator( std::cout ) = " << seq.separator( std::cout ) << '\n';

   return( 0 );
}
