// (C) Copyright 2004: Reece H. Dunn
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <boost/formatter/decorators.hpp>
#include <boost/test/minimal.hpp>

namespace io = boost::io;

int test_main( int, char *[] )
{
   io::decoration< char >              decor1;
   BOOST_TEST( decor1() == std::string());

   io::decoration< char >              decor2( "|" );
   BOOST_TEST( decor2() == "|" );

   io::decoration< char >              decor3( decor2 );
   BOOST_TEST( decor3() == "|" );

   decor1 = ":";
   BOOST_TEST( decor1() == ":" );

   decor2 = decor1;
   BOOST_TEST( decor2() == ":" );

   return( 0 );
}
