// (C) Copyright 2004: Reece H. Dunn
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <boost/formatter/decorators.hpp>
#include <boost/test/minimal.hpp>

namespace io = boost::io;

int test_main( int, char *[] )
{
   io::wrapper_decorators< char >      wrap;
   io::sequence_decorators< char >     seq;

   // internal values

   BOOST_TEST( wrap.open()     == std::string());
   BOOST_TEST( wrap.close()    == std::string());
   BOOST_TEST( seq.open()      == std::string());
   BOOST_TEST( seq.close()     == std::string());
   BOOST_TEST( seq.separator() == std::string());

   // decorated values (defaults)

   BOOST_TEST( wrap.open(     std::cout ) == "[ " );
   BOOST_TEST( wrap.close(    std::cout ) == " ]" );
   BOOST_TEST( seq.open(      std::cout ) == "[ " );
   BOOST_TEST( seq.close(     std::cout ) == " ]" );
   BOOST_TEST( seq.separator( std::cout ) == ", " );

   // decorated values (custom)

   std::cout << io::cdecorate( "< ", " >", "; " );

   BOOST_TEST( wrap.open(     std::cout ) == "< " );
   BOOST_TEST( wrap.close(    std::cout ) == " >" );
   BOOST_TEST( seq.open(      std::cout ) == "< " );
   BOOST_TEST( seq.close(     std::cout ) == " >" );
   BOOST_TEST( seq.separator( std::cout ) == "; " );

   return( 0 );
}
