// (C) Copyright 2004: Reece H. Dunn
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <boost/formatter/decorators.hpp>
#include <boost/test/minimal.hpp>

namespace io = boost::io;

int test_main( int, char *[] )
{
   io::wrapper_decorators< char >      wrap1;
   BOOST_TEST( wrap1.open()  == std::string());
   BOOST_TEST( wrap1.close() == std::string());

   io::wrapper_decorators< char >      wrap2( "<: ", " :>" );
   BOOST_TEST( wrap2.open()  == "<: " );
   BOOST_TEST( wrap2.close() == " :>" );

   io::wrapper_decorators< char >      wrap3( wrap2 );
   BOOST_TEST( wrap3.open()  == "<: " );
   BOOST_TEST( wrap3.close() == " :>" );

   wrap1.decorate( "{ ", " }" );
   BOOST_TEST( wrap1.open()  == "{ " );
   BOOST_TEST( wrap1.close() == " }" );

   wrap3.decorate( wrap1 );
   BOOST_TEST( wrap3.open()  == "{ " );
   BOOST_TEST( wrap3.close() == " }" );

   return( 0 );
}
